/*
 * Copyright 2015 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.retrascope.model.cfg;

/**
 * Default visitor for control flow graph model.
 *
 * @author <a href="mailto:smolov@ispras.ru">Sergey Smolov</a>
 */
public class CfgDefaultVisitor implements CfgVisitor {

  /**
   * Default constructor.
   */
  public CfgDefaultVisitor() {
    /* Empty. */
  }

  @Override
  public Status getStatus() {
    return Status.OK;
  }

  @Override
  public void onRootBegin() {
    /* Empty. */
  }

  @Override
  public void onRootEnd() {
    /* Empty. */
  }

  @Override
  public void onCfgModelBegin() {
    /* Empty. */
  }

  @Override
  public void onCfgModelEnd() {
    /* Empty. */
  }

  @Override
  public void onNodeBegin(final CfgStatement statement) {
    /* Empty. */
  }

  @Override
  public void onNodeEnd(final CfgStatement statement) {
    /* Empty. */
  }

  @Override
  public void onModuleBegin(final CfgModule module) {
    /* Empty. */
  }

  @Override
  public void onModuleEnd(final CfgModule module) {
    /* Empty. */
  }

  @Override
  public void onProcessBegin(final CfgProcess process) {
    /* Empty. */
  }

  @Override
  public void onProcessEnd(final CfgProcess process) {
    /* Empty. */
  }

  @Override
  public void onAssertBegin(final CfgAssertStatement assertStatement) {
    /* Empty. */
  }

  @Override
  public void onAssertEnd(final CfgAssertStatement assertStatement) {
    /* Empty. */
  }

  @Override
  public void onBasicBlockBegin(final CfgBlockStatement block) {
    /* Empty. */
  }

  @Override
  public void onBasicBlockEnd(final CfgBlockStatement block) {
    /* Empty. */
  }

  @Override
  public void onCaseBegin(final CfgCaseStatement caseNode) {
    /* Empty. */
  }

  @Override
  public void onCaseEnd(final CfgCaseStatement caseNode) {
    /* Empty. */
  }

  @Override
  public void onSwitchBegin(final CfgSwitchStatement switchNode) {
    /* Empty. */
  }

  @Override
  public void onSwitchEnd(final CfgSwitchStatement switchNode) {
    /* Empty. */
  }

  @Override
  public void onLoopBegin(final CfgLoopStatement loopStatement) {
    /* Empty. */
  }

  @Override
  public void onLoopEnd(CfgLoopStatement loopStatement) {
    /* Empty. */
  }

  @Override
  public void onWaitBegin(final CfgWaitStatement wait) {
    /* Empty. */
  }

  @Override
  public void onWaitEnd(final CfgWaitStatement wait) {
    /* Empty. */
  }
}
