/*
 * Copyright 2015 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.retrascope.model.efsm;

/**
 * The interface for EFSM module visitors. Typically, EFSM module visitors are used along with EFSM
 * module walkers.
 *
 * @author <a href="mailto:i.melnichenko@deltasolutions.ru">Igor Melnichenko</a>
 *
 * @see EfsmModule
 * @see EfsmModuleWalker
 */
public interface EfsmModuleVisitor extends EfsmVisitor {
  /**
   * Indicates that a walker has started walking across the specified EFSM module.
   *
   * @param efsmModule the visited EFSM module
   */
  void onEfsmModuleBegin(EfsmModule efsmModule);

  /**
   * Indicates that a walker has finished walking across the specified EFSM module.
   *
   * @param efsmModule the visited EFSM module
   */
  void onEfsmModuleEnd(EfsmModule efsmModule);
}
