/*
 * Copyright 2014 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.retrascope.engine.efsm.generator.test;

import org.junit.Before;
import ru.ispras.retrascope.Retrascope;
import ru.ispras.retrascope.model.efsm.EfsmModel;
import ru.ispras.retrascope.model.efsm.examples.SimpleEfsm;
import ru.ispras.retrascope.model.efsm.examples.SimplePipelinedEfsm;
import ru.ispras.retrascope.result.test.TestModel;
import ru.ispras.retrascope.util.Log;

import java.util.HashSet;
import java.util.Set;
import java.util.logging.Logger;

/**
 * The pattern for test cases for an abstract EFSM test generator.
 *
 * @author <a href="mailto:i.melnichenko@deltasolutions.ru">Igor Melnichenko</a>
 */
public abstract class AbstractEfsmTestGeneratorDummyTest {

  protected static final String PARAMETER_PREFIX = "--";
  protected static final String[] TARGET_PARAMETER =
      {AbstractEfsmTestGeneratorDummyTest.PARAMETER_PREFIX, Retrascope.TARGET_PARAM.getLongName(),
      TestModel.TYPE.toString()};

  protected final Logger logger = Log.getLogger(this.getClass());

  protected final Set<EfsmModel> efsmModels = new HashSet<>();

  /**
   * Adds {@link SimpleEfsm} and {@link SimplePipelinedEfsm} models to internal collection.
   */
  @Before
  public void createEfsms() {
    this.efsmModels.add(SimpleEfsm.EFSM_MODEL);
    this.efsmModels.add(SimplePipelinedEfsm.EFSM_MODEL);
  }
}
