/*
 * Copyright 2014 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */

package ru.ispras.retrascope.engine.efsm.generator.test.fate;

import org.junit.Test;

import ru.ispras.retrascope.HdlTestUtils;
import ru.ispras.retrascope.Retrascope;
import ru.ispras.retrascope.result.test.TestModel;

import java.io.IOException;

/**
 * The test for {@link ru.ispras.retrascope.engine.efsm.generator.test.fate.EfsmFateTestGenerator}.
 * VHDL code examples are used as inputs.
 *
 * @author <al href="mailto:i.melnichenko@deltasolutions.ru">Igor Melnichenko</a>
 */
public class EfsmFatePlusTestGeneratorVhdlTestCase {

  @Test
  public void generate() throws IOException {
    HdlTestUtils.runVhdl(TestModel.TYPE.getId(),
        new String[] {
            "--" + Retrascope.ENGINE_PARAM.getLongName(),
            EfsmFatePlusTestGenerator.ENGINE_ID,
            /*"--" + Retrascope.LOG_PARAM.getLongName(),
            "fate+.log",*/
            "--" + EfsmFatePlusTestGenerator.LOOP_LIMIT.getLongName(),
            "25",//25 is for b11
        /*"--" + EfsmFatePlusTestGenerator.SEQUENCE_LENGTH_PARAMETER.getLongName(),
        "0",
        "--" + EfsmFatePlusTestGenerator.SEQUENCES_NUMBER_PARAMETER.getLongName(),
        "0",
        "--" + Retrascope.LOG_LEVEL.getLongName(),
        "DEBUG"*/});
  }
}
