/*
 * Copyright 2015 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ru.ispras.retrascope.util;

import org.junit.Assert;
import org.junit.Test;
import ru.ispras.fortress.data.DataType;
import ru.ispras.fortress.expression.ExprUtils;
import ru.ispras.fortress.expression.Node;
import ru.ispras.fortress.expression.NodeVariable;

/**
 * Test for {@link TransformerUtils} class.
 * @author <a href="mailto:smolov@ispras.ru">Sergey Smolov</a>
 */
public final class TransformerUtilsTestCase {

  /**
   * Default constructor.
   */
  public TransformerUtilsTestCase() {
    /* Empty. */
  }

  @Test
  public void runTest() {

    final Node aVar = new NodeVariable("a", DataType.INTEGER);
    final Node bVar = new NodeVariable("b", DataType.INTEGER);
    final Node cVar = new NodeVariable("c", DataType.INTEGER);
    final Node moreThanTwoOp = NodeUtils.getEquation(aVar, bVar, cVar);

    final Node transformResult =
        ExprUtils.getConjunction(
            NodeUtils.getEquation(bVar, aVar),
            NodeUtils.getEquation(cVar, aVar));

    final Node transformed = TransformerUtils.standardize(moreThanTwoOp);

    Assert.assertEquals(transformResult, transformed);
  }
}
